Index: source/graphics/ObjectBase.h
===================================================================
--- source/graphics/ObjectBase.h	(revision 11919)
+++ source/graphics/ObjectBase.h	(working copy)
@@ -80,6 +80,8 @@
 		int m_Frequency;
 		VfsPath m_ModelFilename;
 		VfsPath m_TextureFilename;
+		VfsPath m_NormalFilename;
+		VfsPath m_SpecularFilename;
 		Decal m_Decal;
 		VfsPath m_Particles;
 		CStr m_Color;
@@ -91,6 +93,8 @@
 	struct Variation
 	{
 		VfsPath texture;
+		VfsPath normal;
+		VfsPath specular;
 		VfsPath model;
 		Decal decal;
 		VfsPath particles;
Index: source/graphics/TerrainTextureEntry.cpp
===================================================================
--- source/graphics/TerrainTextureEntry.cpp	(revision 11919)
+++ source/graphics/TerrainTextureEntry.cpp	(working copy)
@@ -44,7 +44,7 @@
 	// TODO: anisotropy should probably be user-configurable, but we want it to be
 	// at least 2 for terrain else the ground looks very blurry when you tilt the
 	// camera upwards
-	texture.SetMaxAnisotropy(2.0f);
+	texture.SetMaxAnisotropy(2.0f);	
 
 	if (CRenderer::IsInitialised())
 		m_Texture = g_Renderer.GetTextureManager().CreateTexture(texture);
@@ -71,6 +71,25 @@
 		(*it)->AddTerrain(this);
 	
 	m_Tag = utf8_from_wstring(path.Basename().string());
+	
+	if (m_pProperties->HasNormalMap())
+	{
+		//std::wcout << m_pProperties->GetNormalMap().string() << std::endl;
+		CTextureProperties normal(m_pProperties->GetNormalMap());
+		normal.SetWrap(GL_REPEAT);
+		normal.SetMaxAnisotropy(2.0f);
+		if (CRenderer::IsInitialised())
+			m_Normal = g_Renderer.GetTextureManager().CreateTexture(normal);
+	}
+	
+	if (m_pProperties->HasSpecularMap())
+	{
+		CTextureProperties specular(m_pProperties->GetSpecularMap());
+		specular.SetWrap(GL_REPEAT);
+		specular.SetMaxAnisotropy(2.0f);
+		if (CRenderer::IsInitialised())
+			m_Specular = g_Renderer.GetTextureManager().CreateTexture(specular);
+	}
 }
 
 CTerrainTextureEntry::~CTerrainTextureEntry()
Index: source/graphics/weldmesh.h
===================================================================
--- source/graphics/weldmesh.h	(revision 0)
+++ source/graphics/weldmesh.h	(revision 0)
@@ -0,0 +1,49 @@
+/**
+ *  Copyright (C) 2011 by Morten S. Mikkelsen
+ *
+ *  This software is provided 'as-is', without any express or implied
+ *  warranty.  In no event will the authors be held liable for any damages
+ *  arising from the use of this software.
+ *
+ *  Permission is granted to anyone to use this software for any purpose,
+ *  including commercial applications, and to alter it and redistribute it
+ *  freely, subject to the following restrictions:
+ *
+ *  1. The origin of this software must not be misrepresented; you must not
+ *     claim that you wrote the original software. If you use this software
+ *     in a product, an acknowledgment in the product documentation would be
+ *     appreciated but is not required.
+ *  2. Altered source versions must be plainly marked as such, and must not be
+ *     misrepresented as being the original software.
+ *  3. This notice may not be removed or altered from any source distribution.
+ */
+
+
+#ifndef __WELDMESH_H__
+#define __WELDMESH_H__
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+// piRemapTable must be initialized and point to an area in memory
+// with the byte size: iNrVerticesIn * sizeof(int).
+// pfVertexDataOut must be initialized and point to an area in memory
+// with the byte size: iNrVerticesIn * iFloatsPerVert * sizeof(float).
+// At the end of the WeldMesh() call the array pfVertexDataOut will contain
+// unique vertices only. Each entry in piRemapTable contains the index to
+// the new location of the vertex in pfVertexDataOut in units of iFloatsPerVert.
+// Note that this code is suitable for welding both unindexed meshes but also
+// indexed meshes which need to have duplicates removed. In the latter case
+// one simply uses the remap table to convert the old index list to the new vertex array.
+// Finally, the return value is the number of unique vertices found.
+int WeldMesh(int * piRemapTable, float * pfVertexDataOut,
+			  const float pfVertexDataIn[], const int iNrVerticesIn, const int iFloatsPerVert);
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif
\ No newline at end of file
Index: source/graphics/Material.cpp
===================================================================
--- source/graphics/Material.cpp	(revision 11919)
+++ source/graphics/Material.cpp	(working copy)
@@ -32,6 +32,16 @@
 	m_DiffuseTexture = texture;
 }
 
+void CMaterial::SetNormalTexture(const CTexturePtr& texture)
+{
+	m_NormalTexture = texture;
+}
+
+void CMaterial::SetSpecularTexture(const CTexturePtr& texture)
+{
+	m_SpecularTexture = texture;
+}
+
 void CMaterial::SetShaderEffect(const CStr& effect)
 {
 	m_ShaderEffect = CStrIntern(effect);
Index: source/graphics/ObjectBase.cpp
===================================================================
--- source/graphics/ObjectBase.cpp	(revision 11919)
+++ source/graphics/ObjectBase.cpp	(working copy)
@@ -62,6 +62,8 @@
 	EL(prop);
 	EL(mesh);
 	EL(texture);
+	EL(normal);
+	EL(specular);
 	EL(colour);
 	EL(decal);
 	EL(particles);
@@ -151,6 +153,14 @@
 					{
 						currentVariant->m_TextureFilename = VfsPath("art/textures/skins") / option.GetText().FromUTF8();
 					}
+					else if (option_name == el_normal)
+					{
+						currentVariant->m_NormalFilename = VfsPath("art/textures/skins") / option.GetText().FromUTF8();
+					}		
+					else if (option_name == el_specular)
+					{
+						currentVariant->m_SpecularFilename = VfsPath("art/textures/skins") / option.GetText().FromUTF8();
+					}					
 					else if (option_name == el_decal)
 					{
 						XMBAttributeList attrs = option.GetAttributes();
@@ -399,6 +409,12 @@
 		if (! var.m_TextureFilename.empty())
 			variation.texture = var.m_TextureFilename;
 
+		if (! var.m_NormalFilename.empty())
+			variation.normal = var.m_NormalFilename;
+
+		if (! var.m_SpecularFilename.empty())
+			variation.specular = var.m_SpecularFilename;	
+
 		if (! var.m_ModelFilename.empty())
 			variation.model = var.m_ModelFilename;
 
Index: source/graphics/TerrainProperties.h
===================================================================
--- source/graphics/TerrainProperties.h	(revision 11919)
+++ source/graphics/TerrainProperties.h	(working copy)
@@ -66,6 +66,10 @@
 	GroupVector m_Groups;
 
 	void LoadXml(XMBElement node, CXeromyces *pFile, const VfsPath& pathname);
+	
+	VfsPath m_NormalMap;
+	
+	VfsPath m_SpecularMap;
 
 public:
 	CTerrainProperties(CTerrainPropertiesPtr parent);
@@ -111,6 +115,26 @@
 	{
 		return m_Groups;
 	}
+	
+	const VfsPath &GetNormalMap() const
+	{
+		return m_NormalMap;
+	}
+	
+	const VfsPath &GetSpecularMap() const
+	{
+		return m_SpecularMap;
+	}
+	
+	bool HasNormalMap()
+	{
+		return !GetNormalMap().empty();
+	}
+	
+	bool HasSpecularMap()
+	{
+		return !GetSpecularMap().empty();
+	}
 };
 
 #endif
Index: source/graphics/ObjectEntry.cpp
===================================================================
--- source/graphics/ObjectEntry.cpp	(revision 11919)
+++ source/graphics/ObjectEntry.cpp	(working copy)
@@ -61,6 +61,8 @@
 	// Copy the chosen data onto this model:
 
 	m_TextureName = variation.texture;
+	m_NormalName = variation.normal;
+	m_SpecularName = variation.specular;
 	m_ModelName = variation.model;
 
 	if (! variation.color.empty())
@@ -128,6 +130,18 @@
 	texture->Prefetch(); // if we've loaded this model we're probably going to render it soon, so prefetch its texture
 	model->GetMaterial().SetDiffuseTexture(texture);
 
+	CTextureProperties normalProps(m_NormalName);
+	normalProps.SetWrap(GL_CLAMP_TO_EDGE);
+	CTexturePtr normal = g_Renderer.GetTextureManager().CreateTexture(normalProps);
+	//normal->Prefetch(); // if we've loaded this model we're probably going to render it soon, so prefetch its texture
+	model->GetMaterial().SetNormalTexture(normal);
+
+	CTextureProperties specularProps(m_SpecularName);
+	specularProps.SetWrap(GL_CLAMP_TO_EDGE);
+	CTexturePtr specular = g_Renderer.GetTextureManager().CreateTexture(specularProps);
+	//specular->Prefetch(); // if we've loaded this model we're probably going to render it soon, so prefetch its texture
+	model->GetMaterial().SetSpecularTexture(specular);
+
 	// calculate initial object space bounds, based on vertex positions
 	model->CalcStaticObjectBounds();
 
Index: source/renderer/PostprocManager.h
===================================================================
--- source/renderer/PostprocManager.h	(revision 0)
+++ source/renderer/PostprocManager.h	(revision 0)
@@ -0,0 +1,44 @@
+#ifndef INCLUDED_POSTPROCMANAGER
+#define INCLUDED_POSTPROCMANAGER
+
+class PostprocManager
+{
+public:
+	
+	GLuint fbo;
+	GLuint colourTex;
+	GLuint depthTex;
+	GLuint lumaTex;
+	
+	std::vector<std::vector<CShaderTechniquePtr> > renderStages;
+	
+	int width, height;
+	
+	bool isInitialised;
+	
+	PostprocManager();
+	~PostprocManager();
+	
+	void Initialize();
+	
+	void RecreateBuffers();
+	
+	void LoadEffect(const char* name, int stage);
+	
+	void ApplyEffect(CShaderTechniquePtr &shaderTech1);
+	void ApplyPostproc(int stage);
+	
+	void CaptureRenderOutput();
+	
+	void PostprocStage1();
+	void PostprocStage2();
+	
+	void ReleaseRenderOutput();
+	
+	
+	
+
+};
+
+
+#endif //INCLUDED_POSTPROCMANAGER
Index: source/renderer/PatchRData.h
===================================================================
--- source/renderer/PatchRData.h	(revision 11919)
+++ source/renderer/PatchRData.h	(working copy)
@@ -72,8 +72,9 @@
 		CVector3D m_Position;
 		// diffuse color from sunlight
 		SColor4ub m_DiffuseColor;
+		CVector3D m_Normal;
 	};
-	cassert(sizeof(SBaseVertex) == 16);
+	cassert(sizeof(SBaseVertex) == 28);
 
 	struct SSideVertex {
 		// vertex position
@@ -91,9 +92,10 @@
 		// vertex uvs for alpha texture
 		float m_AlphaUVs[2];
 		// add some padding since VBOs prefer power-of-two sizes
-		u32 m_Padding[2];
+		//u32 m_Padding[2];
+		CVector3D m_Normal;
 	};
-	cassert(sizeof(SBlendVertex) == 32);
+	cassert(sizeof(SBlendVertex) == 36);
 
 	// Mixed Fancy/Simple water vertex description data structure
 	struct SWaterVertex {
Index: source/renderer/RenderModifiers.h
===================================================================
--- source/renderer/RenderModifiers.h	(revision 11919)
+++ source/renderer/RenderModifiers.h	(working copy)
@@ -73,6 +73,10 @@
 	 */
 	virtual void PrepareTexture(const CShaderProgramPtr& shader, CTexture& texture) = 0;
 
+	virtual void PrepareNormal(const CShaderProgramPtr& shader, CTexture& normal) = 0;
+
+	virtual void PrepareSpecular(const CShaderProgramPtr& shader, CTexture& specular) = 0;
+
 	/**
 	 * PrepareModel: Called before rendering the given model.
 	 *
@@ -134,6 +138,8 @@
 	// Implementation
 	void BeginPass(const CShaderProgramPtr& shader);
 	void PrepareTexture(const CShaderProgramPtr& shader, CTexture& texture);
+	void PrepareNormal(const CShaderProgramPtr& shader, CTexture& normal);
+	void PrepareSpecular(const CShaderProgramPtr& shader, CTexture& specular);
 	void PrepareModel(const CShaderProgramPtr& shader, CModel* model);
 
 private:
@@ -141,6 +147,8 @@
 	CShaderProgram::Binding m_BindingShadingColor;
 	CShaderProgram::Binding m_BindingPlayerColor;
 	CShaderProgram::Binding m_BindingBaseTex;
+	CShaderProgram::Binding m_BindingNormTex;
+	CShaderProgram::Binding m_BindingSpecTex;
 };
 
 #endif // INCLUDED_RENDERMODIFIERS
Index: source/renderer/ModelRenderer.cpp
===================================================================
--- source/renderer/ModelRenderer.cpp	(revision 11919)
+++ source/renderer/ModelRenderer.cpp	(working copy)
@@ -35,6 +35,7 @@
 #include "renderer/ModelVertexRenderer.h"
 #include "renderer/Renderer.h"
 #include "renderer/RenderModifiers.h"
+#include "renderer/MikktspaceWrap.h"
 
 #include <boost/weak_ptr.hpp>
 
@@ -57,6 +58,13 @@
 #endif
 }
 
+void ModelRenderer::GenTangents(const CModelDefPtr& mdef, std::vector<float>& newVertices)
+{
+	MikkTSpace ms(mdef, newVertices);
+
+	ms.generate();
+}
+
 // Helper function to copy object-space position and normal vectors into arrays.
 void ModelRenderer::CopyPositionAndNormals(
 		const CModelDefPtr& mdef,
@@ -557,6 +565,8 @@
 				m->vertexRenderer->BeginPass(streamflags);
 
 				CTexture* currentTex = NULL;
+				CTexture* currentNorm = NULL;
+				CTexture* currentSpec = NULL;
 				CModelDef* currentModeldef = NULL;
 				CShaderUniforms currentStaticUniforms;
 				// (Texture needs to be rebound after binding a new shader, so we
@@ -581,6 +591,20 @@
 							modifier->PrepareTexture(shader, *currentTex);
 						}
 
+						CTexture* newNorm = model->GetMaterial().GetNormalTexture().get();
+						if (newNorm != currentNorm)
+						{
+							currentNorm = newNorm;
+							modifier->PrepareNormal(shader, *currentNorm);
+						}	
+
+						CTexture* newSpec = model->GetMaterial().GetSpecularTexture().get();
+						if (newSpec != currentSpec)
+						{
+							currentSpec = newSpec;
+							modifier->PrepareSpecular(shader, *currentSpec);
+						}	
+
 						// Bind modeldef when it changes
 						CModelDef* newModeldef = model->GetModelDef().get();
 						if (newModeldef != currentModeldef)
Index: source/renderer/MikktspaceWrap.h
===================================================================
--- source/renderer/MikktspaceWrap.h	(revision 0)
+++ source/renderer/MikktspaceWrap.h	(revision 0)
@@ -0,0 +1,80 @@
+#ifndef INCLUDED_MIKKWRAP
+#define INCLUDED_MIKKWRAP
+
+
+#include <graphics/mikktspace.h>
+
+class MikkTSpace
+{
+
+public:
+	
+	MikkTSpace(const CModelDefPtr& m, std::vector<float>& v);
+
+	void generate();
+	
+private:
+	
+	SMikkTSpaceInterface interface;
+	SMikkTSpaceContext context;
+
+	const CModelDefPtr& model;
+
+	std::vector<float>& newVertices;
+	
+
+	// Returns the number of faces (triangles/quads) on the mesh to be processed.
+	static int getNumFaces(const SMikkTSpaceContext *pContext);
+
+
+	// Returns the number of vertices on face number iFace
+	// iFace is a number in the range {0, 1, ..., getNumFaces()-1}
+	static int getNumVerticesOfFace(const SMikkTSpaceContext *pContext, const int iFace);
+
+
+	// returns the position/normal/texcoord of the referenced face of vertex number iVert.
+	// iVert is in the range {0,1,2} for triangles and {0,1,2,3} for quads.
+	static void getPosition(const SMikkTSpaceContext *pContext, 
+			float fvPosOut[], const int iFace, const int iVert);
+
+	static void getNormal(const SMikkTSpaceContext *pContext, 
+			float fvNormOut[], const int iFace, const int iVert);
+
+	static void getTexCoord(const SMikkTSpaceContext *pContext, 
+			float fvTexcOut[], const int iFace, const int iVert);
+
+
+	// either (or both) of the two setTSpace callbacks can be set.
+	// The call-back m_setTSpaceBasic() is sufficient for basic normal mapping.
+
+	// This function is used to return the tangent and fSign to the application.
+	// fvTangent is a unit length vector.
+	// For normal maps it is sufficient to use the following simplified version of the bitangent which is generated at pixel/vertex level.
+	// bitangent = fSign * cross(vN, tangent);
+	// Note that the results are returned unindexed. It is possible to generate a new index list
+	// But averaging/overwriting tangent spaces by using an already existing index list WILL produce INCRORRECT results.
+	// DO NOT! use an already existing index list.
+	//void setTSpaceBasic(const MikkTSpace *parent, const SMikkTSpaceContext *pContext, 
+	//		const float fvTangent[], const float fSign, const int iFace, const int iVert);
+
+
+	// This function is used to return tangent space results to the application.
+	// fvTangent and fvBiTangent are unit length vectors and fMagS and fMagT are their
+	// true magnitudes which can be used for relief mapping effects.
+	// fvBiTangent is the "real" bitangent and thus may not be perpendicular to fvTangent.
+	// However, both are perpendicular to the vertex normal.
+	// For normal maps it is sufficient to use the following simplified version of the bitangent which is generated at pixel/vertex level.
+	// fSign = bIsOrientationPreserving ? 1.0f : (-1.0f);
+	// bitangent = fSign * cross(vN, tangent);
+	// Note that the results are returned unindexed. It is possible to generate a new index list
+	// But averaging/overwriting tangent spaces by using an already existing index list WILL produce INCRORRECT results.
+	// DO NOT! use an already existing index list.
+	static void setTSpace(const SMikkTSpaceContext * pContext, const float fvTangent[], 
+			const float fvBiTangent[], const float fMagS, const float fMagT, 
+			const tbool bIsOrientationPreserving, const int iFace, const int iVert);
+
+
+};
+
+
+#endif // INCLUDED_MIKKWRAP
\ No newline at end of file
Index: source/renderer/PostprocManager.cpp
===================================================================
--- source/renderer/PostprocManager.cpp	(revision 0)
+++ source/renderer/PostprocManager.cpp	(revision 0)
@@ -0,0 +1,242 @@
+#include "precompiled.h"
+
+#include "lib/ogl.h"
+#include "maths/MathUtil.h"
+
+#include "gui/GUIutil.h"
+#include "lib/bits.h"
+
+#include "graphics/ShaderManager.h"
+#include "renderer/Renderer.h"
+
+#include "renderer/PostprocManager.h"
+
+
+PostprocManager::PostprocManager()
+{
+	isInitialised = false;
+	fbo = 0;
+	colourTex = 0;
+	depthTex = 0;
+	lumaTex = 0;	
+}
+
+
+PostprocManager::~PostprocManager()
+{
+	if (isInitialised)
+	{
+		if (fbo) pglDeleteFramebuffersEXT(1, &fbo);
+		if (colourTex) glDeleteTextures(1, &colourTex);
+		if (depthTex) glDeleteTextures(1, &depthTex);
+		if (lumaTex) glDeleteTextures(1, &lumaTex);
+	}
+}
+
+void PostprocManager::Initialize()
+{
+	RecreateBuffers();
+	isInitialised = true;
+	
+	renderStages = std::vector<std::vector<CShaderTechniquePtr> >(5);
+	
+	LoadEffect("ssao", 0);
+	
+	LoadEffect("hdr",   1);
+	LoadEffect("bloom", 1);
+}
+
+
+void PostprocManager::RecreateBuffers()
+{
+	if (isInitialised)
+	{
+		if (fbo) pglDeleteFramebuffersEXT(1, &fbo);
+		if (colourTex) glDeleteTextures(1, &colourTex);
+		if (depthTex) glDeleteTextures(1, &depthTex);
+		if (lumaTex) glDeleteTextures(1, &lumaTex);
+	}
+		
+	
+	/*width = height = (int)round_up_to_pow2((unsigned)std::max(g_Renderer.GetWidth(), g_Renderer.GetHeight()));
+	width = std::min(width, (int)ogl_max_tex_size);
+	height = std::min(height, (int)ogl_max_tex_size);*/
+	
+	width = g_Renderer.GetWidth();
+	height = g_Renderer.GetHeight();
+
+	
+	glGenTextures(1, (GLuint*)&colourTex);
+	glBindTexture(GL_TEXTURE_2D, colourTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F, width, height, 0, GL_RGBA,
+			GL_HALF_FLOAT, 0);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+
+
+	glGenTextures(1, (GLuint*)&depthTex);
+	glBindTexture(GL_TEXTURE_2D, depthTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32, width, height,
+		      0, GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE,NULL);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE,
+			GL_NONE);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+	
+
+	glGenTextures(1, (GLuint*)&lumaTex);
+	glBindTexture(GL_TEXTURE_2D, lumaTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE16, width, height,
+		  0, GL_LUMINANCE, GL_UNSIGNED_BYTE, 0);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+	
+	glBindTexture(GL_TEXTURE_2D, 0);
+
+	/**pglGenFramebuffersEXT(1, &fbo);
+	pglBindFramebufferEXT(GL_FRAMEBUFFER, fbo);
+	pglFramebufferTexture2DEXT(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, colourTex, 0);
+	pglFramebufferTexture2DEXT(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, depthTex, 0);
+	//glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT, GL_TEXTURE_2D, colourTex, 0);
+
+	pglBindFramebufferEXT(GL_FRAMEBUFFER, 0);*/
+}
+
+
+void PostprocManager::CaptureRenderOutput()
+{
+	glBindTexture(GL_TEXTURE_2D, colourTex);	
+	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F, 0, 0, width, height, 0);
+	glBindTexture(GL_TEXTURE_2D, depthTex);
+	glCopyTexImage2D(GL_TEXTURE_2D,0,GL_DEPTH_COMPONENT, 0, 0, width, height, 0);
+	glBindTexture(GL_TEXTURE_2D, lumaTex);
+	glCopyTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE16, 0, 0, width, height, 0);
+}
+
+
+void PostprocManager::ReleaseRenderOutput()
+{
+	//pglBindFramebufferEXT(GL_FRAMEBUFFER, 0);
+}
+
+void PostprocManager::LoadEffect(const char* name, int stage)
+{
+	CShaderTechniquePtr shaderTech1 = g_Renderer.GetShaderManager().LoadEffect(name);
+	
+	renderStages[stage].push_back(shaderTech1);
+	
+}
+
+void PostprocManager::ApplyEffect(CShaderTechniquePtr &shaderTech1)
+{
+	CaptureRenderOutput();
+	
+	glDisable(GL_DEPTH_TEST);
+	glDepthMask(GL_FALSE);
+
+	shaderTech1->BeginPass();
+	CShaderProgramPtr shader = shaderTech1->GetShader();
+	
+	shader->Bind();	
+	
+	shader->BindTexture("bgl_RenderedTexture", colourTex);
+	
+	shader->BindTexture("bgl_DepthTexture", depthTex);
+	
+	shader->BindTexture("bgl_LuminanceTexture", lumaTex);
+	
+	shader->Uniform("bgl_RenderedTextureWidth", width);
+	shader->Uniform("bgl_RenderedTextureHeight", height);
+	
+	glBegin(GL_QUADS);
+	    glColor4f(1.f, 1.f, 1.f, 1.f);
+	    glTexCoord2f(1.0, 1.0);	glVertex2f(1,1);
+	    glTexCoord2f(0.0, 1.0);	glVertex2f(-1,1);	    
+	    glTexCoord2f(0.0, 0.0);	glVertex2f(-1,-1);
+	    glTexCoord2f(1.0, 0.0);	glVertex2f(1,-1);
+	glEnd();
+	
+	shader->Unbind();
+	
+	shaderTech1->EndPass();	
+		
+	glDepthMask(GL_TRUE);
+	glEnable(GL_DEPTH_TEST);
+}
+
+
+
+void PostprocManager::ApplyPostproc(int stage)
+{
+	if (!isInitialised) 
+		return;
+	
+	std::vector<CShaderTechniquePtr> &effects = renderStages[stage];
+	
+	//std::cout << "EFFECT!!! " << effects.size() << std::endl;
+	
+	for (size_t i = 0; i < effects.size(); i++)
+	{		
+		ApplyEffect(effects[i]);
+	}
+}
+
+/*void PostprocManager::PostprocStage2()
+{
+	CShaderTechniquePtr shaderTech2 = g_Renderer.GetShaderManager().LoadEffect("hdr");
+		
+	shaderTech2->BeginPass();
+	CShaderProgramPtr shader2 = shaderTech2->GetShader();
+	
+	shader2->Bind();
+	
+	shader2->BindTexture("bgl_RenderedTexture", texname[0]);
+	shader2->BindTexture("bgl_DepthTexture", texname[1]);
+	shader2->BindTexture("bgl_LuminanceTexture", texname[2]);
+	
+	glBegin(GL_QUADS);
+	    glColor4f(1.f, 1.f, 1.f, 1.f);
+	    glTexCoord2f(1.0, 1.0);	glVertex2f(1,1);
+	    glTexCoord2f(0.0, 1.0);	glVertex2f(-1,1);
+	    //glTexCoord2f(1.0, 1.0);	glVertex2f(1,0);
+	    //glTexCoord2f(0.0, 1.0);	glVertex2f(-1,0);
+	    glTexCoord2f(0.0, 0.0);	glVertex2f(-1,-1);
+	    glTexCoord2f(1.0, 0.0);	glVertex2f(1,-1);
+	glEnd();
+	
+	shaderTech2->EndPass();
+	shader2->Unbind();
+	
+	
+		
+	
+	CShaderTechniquePtr shaderTech3 = g_Renderer.GetShaderManager().LoadEffect("bloom");
+		
+	shaderTech3->BeginPass();
+	CShaderProgramPtr shader3 = shaderTech3->GetShader();
+	
+	shader3->Bind();
+	
+	shader3->BindTexture("bgl_RenderedTexture", texname[0]);
+	shader3->BindTexture("bgl_DepthTexture", texname[1]);
+	shader3->BindTexture("bgl_LuminanceTexture", texname[2]);
+	
+	glBegin(GL_QUADS);
+	    glColor4f(1.f, 1.f, 1.f, 1.f);
+	    glTexCoord2f(1.0, 1.0);	glVertex2f(1,1);
+	    glTexCoord2f(0.0, 1.0);	glVertex2f(-1,1);
+	    //glTexCoord2f(1.0, 1.0);	glVertex2f(1,0);
+	    //glTexCoord2f(0.0, 1.0);	glVertex2f(-1,0);
+	    glTexCoord2f(0.0, 0.0);	glVertex2f(-1,-1);
+	    glTexCoord2f(1.0, 0.0);	glVertex2f(1,-1);
+	glEnd();
+	
+	shaderTech3->EndPass();
+	shader3->Unbind();
+}*/
\ No newline at end of file
Index: source/renderer/InstancingModelRenderer.cpp
===================================================================
--- source/renderer/InstancingModelRenderer.cpp	(revision 11919)
+++ source/renderer/InstancingModelRenderer.cpp	(working copy)
@@ -31,6 +31,7 @@
 #include "graphics/LightEnv.h"
 #include "graphics/Model.h"
 #include "graphics/ModelDef.h"
+#include "graphics/weldmesh.h"
 
 #include "renderer/InstancingModelRenderer.h"
 #include "renderer/Renderer.h"
@@ -49,6 +50,7 @@
 	/// Position, normals and UV are all static
 	VertexArray::Attribute m_Position;
 	VertexArray::Attribute m_Normal;
+	VertexArray::Attribute m_Tangent;
 	VertexArray::Attribute m_UV;
 	VertexArray::Attribute m_BlendJoints; // valid iff gpuSkinning == true
 	VertexArray::Attribute m_BlendWeights; // valid iff gpuSkinning == true
@@ -76,6 +78,10 @@
 	m_UV.type = GL_FLOAT;
 	m_UV.elems = 2;
 	m_Array.AddAttribute(&m_UV);
+	
+	m_Tangent.type = GL_FLOAT;
+	m_Tangent.elems = 4;
+	m_Array.AddAttribute(&m_Tangent);
 
 	if (gpuSkinning)
 	{
@@ -87,16 +93,51 @@
 		m_BlendWeights.elems = 4;
 		m_Array.AddAttribute(&m_BlendWeights);
 	}
+	
 
-	m_Array.SetNumVertices(numVertices);
+	std::vector<float> newVertices;
+	
+	SModelVertex* vertices = mdef->GetVertices();
+	
+	ModelRenderer::GenTangents(mdef, newVertices);
+	
+	int numVertexAttrs = 3 + 3 + 2 + 4;
+	
+	int vert = newVertices.size() / numVertexAttrs;
+	
+	std::vector<int> remapTable(vert);
+	std::vector<float> vertexDataIn(vert * numVertexAttrs); 
+	std::vector<float> vertexDataOut(vert * numVertexAttrs);
+		
+	vertexDataIn = newVertices;
+
+	int numVertices2 = WeldMesh(&remapTable[0], &vertexDataOut[0],
+			  &vertexDataIn[0], vert, numVertexAttrs);
+
+	m_Array.SetNumVertices(numVertices2);
 	m_Array.Layout();
 
 	VertexArrayIterator<CVector3D> Position = m_Position.GetIterator<CVector3D>();
 	VertexArrayIterator<CVector3D> Normal = m_Normal.GetIterator<CVector3D>();
 	VertexArrayIterator<float[2]> UVit = m_UV.GetIterator<float[2]>();
+	VertexArrayIterator<CVector4D> Tangent = m_Tangent.GetIterator<CVector4D>();
 
-	ModelRenderer::CopyPositionAndNormals(mdef, Position, Normal);
-	ModelRenderer::BuildUV(mdef, UVit);
+	for (int i = 0; i < numVertices2; i++)
+	{	
+		int p = remapTable[i];
+		
+		int q = numVertexAttrs * i;
+		
+		Position[i] = CVector3D(vertexDataOut[q + 0], vertexDataOut[q + 1], vertexDataOut[q + 2]);
+		
+		Normal[i] = CVector3D(vertexDataOut[q + 3], vertexDataOut[q + 4], vertexDataOut[q + 5]);
+		
+		UVit[i][0] = vertexDataOut[q + 6];
+		UVit[i][1] = vertexDataOut[q + 7];
+		
+		Tangent[i] = CVector4D(vertexDataOut[q + 8], vertexDataOut[q + 9], vertexDataOut[q + 10], 
+				       vertexDataOut[q + 11]);
+	}
 
 	if (gpuSkinning)
 	{
@@ -118,7 +159,20 @@
 
 	m_IndexArray.SetNumVertices(mdef->GetNumFaces()*3);
 	m_IndexArray.Layout();
-	ModelRenderer::BuildIndices(mdef, m_IndexArray.GetIterator());
+	
+	VertexArrayIterator<u16> Indices = m_IndexArray.GetIterator();
+	
+	size_t idxidx = 0;
+	SModelFace* faces = mdef->GetFaces();	
+
+	for (size_t j = 0; j < mdef->GetNumFaces(); ++j) {	
+		Indices[idxidx++]=remapTable[j * 3 + 0];
+		Indices[idxidx++]=remapTable[j * 3 + 1];
+		Indices[idxidx++]=remapTable[j * 3 + 2];
+	}
+	
+	
+	
 	m_IndexArray.Upload();
 	m_IndexArray.FreeBackingStore();
 }
@@ -211,6 +265,8 @@
 	if (streamflags & STREAM_UV0)
 		shader->TexCoordPointer(GL_TEXTURE0, 2, GL_FLOAT, stride, base + m->imodeldef->m_UV.offset);
 
+	shader->VertexAttribPointer("a_tangent", 4, GL_FLOAT, GL_TRUE, stride, base + m->imodeldef->m_Tangent.offset);
+
 	// GPU skinning requires extra attributes to compute positions/normals
 	if (m->gpuSkinning)
 	{
Index: source/renderer/Renderer.cpp
===================================================================
--- source/renderer/Renderer.cpp	(revision 11919)
+++ source/renderer/Renderer.cpp	(working copy)
@@ -66,6 +66,7 @@
 #include "renderer/TerrainRenderer.h"
 #include "renderer/VertexBufferManager.h"
 #include "renderer/WaterManager.h"
+#include "renderer/PostprocManager.h"
 
 
 ///////////////////////////////////////////////////////////////////////////////////
@@ -271,6 +272,8 @@
 
 	/// Shadow map
 	ShadowMap shadow;
+	
+	PostprocManager postprocManager;
 
 	/// Various model renderers
 	struct Models
@@ -631,6 +634,8 @@
 	// Let component renderers perform one-time initialization after graphics capabilities and
 	// the shader path have been determined.
 	m->overlayRenderer.Initialize();
+	
+	m->postprocManager.Initialize();
 
 	return true;
 }
@@ -639,10 +644,12 @@
 void CRenderer::Resize(int width,int height)
 {
 	// need to recreate the shadow map object to resize the shadow texture
-	m->shadow.RecreateTexture();
+	m->shadow.RecreateTexture();	
 
 	m_Width = width;
 	m_Height = height;
+	
+	m->postprocManager.RecreateBuffers();
 }
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -705,7 +712,7 @@
 // SetRenderPath: Select the preferred render path.
 // This may only be called before Open(), because the layout of vertex arrays and other
 // data may depend on the chosen render path.
-void CRenderer::SetRenderPath(RenderPath rp)
+void CRenderer::SetRenderPath(RenderPath rp) 
 {
 	if (!m->IsOpen)
 	{
@@ -1416,6 +1423,11 @@
 		}
 	}
 
+	RenderModels(context);
+	ogl_WarnIfError();	
+
+	m->postprocManager.ApplyPostproc(0);
+
 	// render submitted patches and models
 	RenderPatches(context);
 	ogl_WarnIfError();
@@ -1428,9 +1440,6 @@
 	m->overlayRenderer.RenderOverlaysBeforeWater();
 	ogl_WarnIfError();
 
-	RenderModels(context);
-	ogl_WarnIfError();
-
 	// render water
 	if (m_WaterManager->m_RenderWater && g_Game && waterScissor.GetVolume() > 0)
 	{
@@ -1452,6 +1461,8 @@
 		ogl_WarnIfError();
 	}
 
+	m->postprocManager.ApplyPostproc(1);
+
 	// render debug-related terrain overlays
 	ITerrainOverlay::RenderOverlaysAfterWater();
 	ogl_WarnIfError();
